#include "AWG.h"

AWG::AWG(PegRect rect, CPMainFrame* frame):CPModuleWindow(rect,0,0,frame)
{
init();
}

int AWG::init()
{   
   	const WORD wStyle = FF_NONE|TJ_LEFT|AF_TRANSPARENT| TT_COPY;
	const SIGNED margin = 10;
	const SIGNED width=mClient.Width()-2*margin;
    
 	PegPrompt* label_p = new PegPrompt(margin, 80, width, "Caracteristicas:",0,wStyle);
	AddR(label_p);
 	PegPrompt* label_c = new PegPrompt(margin, 10, width, "Numero AWG:",0,wStyle);
	AddR(label_c);
 	
 	PegRect ListRect;
    int i,j,k;
    CP_CHAR auxchar;
    unsigned char * cadena;
    CPString cadenaS;
    
 	ListRect.Set(10, 20, MAINFRAME_RIGHT-10, 65); 
    pList = new PegVertList(ListRect,ID_VERTLIST);
  
    for(i=1;i<=44;i++)
    {
        j=i-4; 
        if(j<0)
        {
            cadenaS = "0";
            for(k=0;k>j;k--)
            {
                cadenaS += "0";
            }             
        }    
        else
        {
            cadena = CP_IntToString(j,&auxchar);
            cadenaS = (CPString)cadena[0]+(CPString)cadena[1];               
        }    
        pList->AddToEnd(new PegPrompt(0, 0, "AWG "+cadenaS, 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY)); 
    }    
    pList->SetScrollMode(WSM_VSCROLL); 
    pList->SetSignals(SIGMASK(PSF_LIST_SELECT));
    
    AddR(pList);
    
 	ListRect.Set(10, 90, MAINFRAME_RIGHT-10, 180); 
    cList = new PegVertList(ListRect,ID_VERTLIST2);
    AddR(cList);
    
    Calcula(-3);
    Draw();
    SetDefaultFocus(pList);
	
    return 0;
}

void AWG::Draw()
{
	BeginDraw();
	Invalidate(mClient);
	DrawFrame();
	DrawChildren();
	EndDraw();
}

SIGNED AWG::Message(const PegMessage &Mesg)
{
	switch(Mesg.wType)
	{
        case SIGNAL(ID_VERTLIST,PSF_LIST_SELECT):
        {
            cList->Clear();
            Calcula(pList->GetSelectedIndex()-3);            
            Draw();
        }
        break;    		
		default:
		return CPModuleWindow::Message(Mesg);
	}
	return 0;
}

WORD AWG::Dialog(char* title, char* message)
{
	PegRect rr = GetMainFrame()->TopAppRectangle();
	rr.wBottom -= 30;
	rr.wRight -= 10;
	rr.wTop += 10;
	rr.wLeft += 10;
	PegMessageWindow *msg = new PegMessageWindow(rr, title, message, MW_OK, 0,0,0);
	return msg->Execute();
}

void AWG::Calcula(short numawg)
{   
    OBCD aux, aux2, aux3;
    Cal_shortto_OBC(numawg,&aux); // aux = n AWG
    Cal_shortto_OBC(36,&aux2);
    Cal_sub_OBC(&aux2,&aux); // aux2 = 36-AWG
    Cal_shortto_OBC(39,&aux);
    Cal_div_OBC(&aux2,&aux); // aux2 = (36-AWG)/39
    Cal_shortto_OBC(92,&aux);
    Cal_pow_OBC(&aux,&aux2); // aux = 92^((36-AWG)/39)
    ExecuteToOBCD("0.005",aux2);
    Cal_mul_OBC(&aux,&aux2); // aux = 0.005*92^((36-AWG)/39)
    aux3 = aux;
    Cal_cintx_OBC(&aux3,5);
            
    cList->AddToEnd(new PegPrompt(0, 0, "diam. = "+CPString(aux3)+" inches", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
            
    ExecuteToOBCD("25.4",aux2);
    Cal_mul_OBC(&aux,&aux2);
    aux3 = aux;
    Cal_cintx_OBC(&aux3,5);
            
    cList->AddToEnd(new PegPrompt(0, 0, "diam. = "+CPString(aux3)+" mm", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
            
    PEGCHAR* chr2 = "\xED\xF2"; 
    PEGCHAR* chrohm = "\xEC\x7E"; 
    PEGCHAR* chrinv = "\xED\xFC"; 
    Cal_setpiq_OBC(&aux2);
    Cal_square_OBC(&aux);
    Cal_mul_OBC(&aux,&aux2);
    aux3=aux;
    Cal_cintx_OBC(&aux3,5);
                       
    cList->AddToEnd(new PegPrompt(0, 0, "Secc. = "+CPString(aux3)+" mm"+(CPString)chr2, 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
            
    ExecuteToOBCD("0.0254",aux2);
    Cal_setpiq_OBC(&aux3);
    Cal_square_OBC(&aux2);
    Cal_mul_OBC(&aux3,&aux2);
    aux2 = aux; // aux2 = A en mm
    Cal_div_OBC(&aux,&aux3);
    Cal_shortto_OBC(1000,&aux3);
    Cal_div_OBC(&aux,&aux3);
    Cal_cintx_OBC(&aux,5);
    aux3 = aux;
            
    cList->AddToEnd(new PegPrompt(0, 0, "Secc. = "+CPString(aux)+" kcmil", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
 
    ExecuteToOBCD("16.78",aux);
    Cal_div_OBC(&aux,&aux2);
    Cal_cintx_OBC(&aux,5);
    
    cList->AddToEnd(new PegPrompt(0, 0, "Resis = "+CPString(aux)+" "+CPString(chrohm)+"/km", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
           
    ExecuteToOBCD("8.96",aux);
    Cal_mul_OBC(&aux,&aux2);
    Cal_cintx_OBC(&aux,5);
    cList->AddToEnd(new PegPrompt(0, 0, "Peso = "+CPString(aux)+" Kg/km", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));

    ExecuteToOBCD("0.7",aux);
    Cal_div_OBC(&aux3,&aux);
    Cal_cintx_OBC(&aux3,5);
    cList->AddToEnd(new PegPrompt(0, 0, "Ipow = "+CPString(aux3)+" A", 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));

  
    ExecuteToOBCD("1.1234",aux);
    Cal_shortto_OBC(numawg+3,&aux2);
    Cal_pow_OBC(&aux,&aux2);
    ExecuteToOBCD("2.17",aux2);
    Cal_mul_OBC(&aux,&aux2);
    aux3 = aux;
    Cal_cintx_OBC(&aux3,4);
    cList->AddToEnd(new PegPrompt(0, 0, "Turns wire = "+CPString(aux3)+" inch"+CPString(chrinv), 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
   
    ExecuteToOBCD("2.54",aux2);
    Cal_div_OBC(&aux,&aux2);
    Cal_cintx_OBC(&aux,4);
    cList->AddToEnd(new PegPrompt(0, 0, "Turns wire = "+CPString(aux)+" cm"+CPString(chrinv), 10, FF_NONE|TJ_LEFT|AF_ENABLED|TT_COPY));
    
}   

extern "C" char *ExtensionGetLang(ID_MESSAGE MessageNo)
{
return "";
}
